package pl.net.linux.krzak.kchat.sac;
/*****************************/
/* kChat v2.0pre2	     */
/* kChatSac v0.9	     */
/* krzak@linux.net.pl        */
/* Marcin Krzyzanowski       */
/* http://krzak.linux.net.pl */
/* License: GPL              */
/*****************************/
/* Copyright (C) 2001  Marcin Krzyzanowski <krzak@linux.net.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;
import java.net.Socket;

public class SacNet extends Thread {

    private SacMainWindow  main       = null;
    private Socket clientS    = null;
    BufferedReader br         = null;
    PrintWriter    pw         = null;
    SacProtocol  protocol     = null;
    public boolean connected  = false; 

    public SacNet(String hosttmp,String port,SacMainWindow m) {
    super("SacNet");
    main  = m;
    try {
    if ((port == null) || (port.equals(""))) { port = new String("1979"); }
    clientS = new Socket(hosttmp,new Integer(port).parseInt(port));
    br = new BufferedReader(new InputStreamReader(clientS.getInputStream()));
    pw = new PrintWriter(new BufferedOutputStream(clientS.getOutputStream(), 1024), false);
    connected = true;
    } catch (IOException e) {
	main.status.setText("Connection Failed");
	connected=false;
	}
    }

    public void run()
    {
    try {
	String liniaWe, liniaWy;
	liniaWe = new String();
	liniaWy = new String();
	protocol = new SacProtocol(main);
/*	    while (br!=null) {
	    if ((br != null)&&(br.ready())) 
		liniaWe = br.readLine();
		
	    if (liniaWe != null)
		protocol.parse(liniaWe);
		else break;
	    }
*/
	while ((br!=null) && ((liniaWe = br.readLine()) != null)) {
	    if ((br!=null)&&(br.ready())) {
//		liniaWe = br.readLine();
		if (liniaWe != null)
		protocol.parse(liniaWe);
		}
	    }	    
	}
 catch (IOException e)
 {
	    try {
	    if (br !=null) {
		br.close();
//		br=null;
		}
	    if (pw !=null) {
		pw.close();
//		pw=null;
		}
	    if (clientS !=null) {
		clientS.close();
//		clientS = null;
		}
	    } catch (IOException ex) { ex.printStackTrace(); }
//	    e.printStackTrace();
	    }
    }

    public synchronized void disconnect() {
	try {
	if (pw != null)
	    send("*CLOSE");
	if (br !=null) {
	    br.close();
//	    br=null;
	    }
	if (pw !=null) {
	    pw.close();
//	    pw=null;
	    }
	if (clientS !=null) {
	    clientS.close();
//	    clientS=null;
	    }
	main.status.setText("Disconnect");
	connected=false;
	} catch (IOException e) {
	    e.printStackTrace();
	    }
    }

    public void send(String data) {
	if ((data != null)&&(pw!=null)){
	    data.trim();
	    pw.println(data + "\r\n");
	    pw.flush();
	    }
 else {
	    connected=false;
	    main.status.setText("Disconnect");
	    }
    }

}